<?php
function total_reviews_facebook_page($page_id, $page_name, $rating, $reviews, $open_link, $nofollow_link, $show_powered = true) {
    ?>
    <div class="wp-facebook-left">
        <img src="https://graph.facebook.com/<?php echo $page_id; ?>/picture" alt="<?php echo $page_name; ?>">
    </div>
    <div class="wp-facebook-right">
        <div class="wp-facebook-name">
            <?php echo total_reviews_facebook_anchor('https://fb.com/' . $page_id, '', '<span>' . $page_name . '</span>', $open_link, $nofollow_link); ?>
        </div>
        <div>
            <span class="wp-facebook-rating"><?php echo $rating; ?></span>
            <span class="wp-facebook-stars"><?php total_reviews_facebook_stars($rating); ?></span>
        </div>
        <?php if ($show_powered) { ?>
        <div class="wp-facebook-powered">powered by <span>Facebook</span></div>
        <?php } ?>
    </div>
    <?php
}

function total_reviews_facebook_reviews($page_id, $reviews, $open_link, $nofollow_link) {
    ?>
    <div class="wp-facebook-reviews">
    <?php
    if (count($reviews) > 0) {
        foreach ($reviews as $review) { ?>
        <div class="wp-facebook-review">
            <div class="wp-facebook-left">
                <img src="https://graph.facebook.com/<?php echo $review->reviewer->id; ?>/picture" alt="<?php echo $review->reviewer->name; ?>" onerror="if(this.src!='<?php echo TOTAL_REVIEWS_FB_AVATAR; ?>')this.src='<?php echo TOTAL_REVIEWS_FB_AVATAR; ?>';">
            </div>
            <div class="wp-facebook-right">
                <?php total_reviews_facebook_anchor('https://www.facebook.com/app_scoped_user_id/' . $review->reviewer->id, 'wp-facebook-name', $review->reviewer->name, $open_link, $nofollow_link); ?>
                <div class="wp-facebook-time" data-time="<?php echo $review->created_time; ?>"><?php echo $review->created_time; ?></div>
                <div class="wp-facebook-feedback">
                    <span class="wp-facebook-stars"><?php echo total_reviews_facebook_stars($review->rating); ?></span>
                    <?php if (isset($review->review_text)) { ?>
                    <span class="wp-facebook-text"><?php echo total_reviews_facebook_trim_text($review->review_text, 0); ?></span>
                    <?php } ?>
                </div>
            </div>
        </div>
        <?php
        }
    }
    ?>
    </div>
    <?php /*$seeAllReviews = total_reviews_text('See All Reviews'); total_reviews_facebook_anchor('https://fb.com/' . $page_id, 'wp-facebook-url', $seeAllReviews, true, true);*/
}

function total_reviews_facebook_stars($rating) {
    ?><span class="wp-stars"><?php
    foreach (array(1,2,3,4,5) as $val) {
        $score = $rating - $val;
        if ($score >= 0) {
            ?><span class="wp-star"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="16" height="16" viewBox="0 0 1792 1792"><path d="M1728 647q0 22-26 48l-363 354 86 500q1 7 1 20 0 21-10.5 35.5t-30.5 14.5q-19 0-40-12l-449-236-449 236q-22 12-40 12-21 0-31.5-14.5t-10.5-35.5q0-6 2-20l86-500-364-354q-25-27-25-48 0-37 56-46l502-73 225-455q19-41 49-41t49 41l225 455 502 73q56 9 56 46z" fill="#4080ff"></path></svg></span><?php
        } else if ($score > -1 && $score < 0) {
            ?><span class="wp-star"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="16" height="16" viewBox="0 0 1792 1792"><path d="M1250 957l257-250-356-52-66-10-30-60-159-322v963l59 31 318 168-60-355-12-66zm452-262l-363 354 86 500q5 33-6 51.5t-34 18.5q-17 0-40-12l-449-236-449 236q-23 12-40 12-23 0-34-18.5t-6-51.5l86-500-364-354q-32-32-23-59.5t54-34.5l502-73 225-455q20-41 49-41 28 0 49 41l225 455 502 73q45 7 54 34.5t-24 59.5z" fill="#4080ff"></path></svg></span><?php
        } else {
            ?><span class="wp-star"><svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="16" height="16" viewBox="0 0 1792 1792"><path d="M1201 1004l306-297-422-62-189-382-189 382-422 62 306 297-73 421 378-199 377 199zm527-357q0 22-26 48l-363 354 86 500q1 7 1 20 0 50-41 50-19 0-40-12l-449-236-449 236q-22 12-40 12-21 0-31.5-14.5t-10.5-35.5q0-6 2-20l86-500-364-354q-25-27-25-48 0-37 56-46l502-73 225-455q19-41 49-41t49 41l225 455 502 73q56 9 56 46z" fill="#ccc"></path></svg></span><?php
        }
    }
    ?></span><?php
}

function total_reviews_facebook_rstrpos($haystack, $needle, $offset) {
    $size = strlen ($haystack);
    $pos = strpos (strrev($haystack), $needle, $size - $offset);

    if ($pos === false)
        return false;

    return $size - $pos;
}

function total_reviews_facebook_trim_text($text, $size) {
    if ($size > 0 && strlen($text) > $size) {
        $visible_text = $text;
        $invisible_text = '';
        $idx = total_reviews_facebook_rstrpos($text, ' ', $size);
        if ($idx < 1) {
            $idx = $size;
        }
        if ($idx > 0) {
            $visible_text = substr($text, 0, $idx);
            $invisible_text = substr($text, $idx, strlen($text));
        }
        echo $visible_text;
        if (strlen($invisible_text) > 0) {
            ?><span class="wp-more"><?php echo $invisible_text; ?></span><span class="wp-more-toggle" onclick="this.previousSibling.className='';this.textContent='';"><?php echo total_reviews_text('read more'); ?></span><?php
        }
    } else {
        echo $text;
    }
}

function total_reviews_facebook_anchor($url, $class, $text, $open_link, $nofollow_link) {
    ?><a href="<?php echo $url; ?>" class="<?php echo $class; ?>" <?php if ($open_link) { ?>target="_blank"<?php } ?> <?php if ($nofollow_link) { ?>rel="nofollow"<?php } ?>><?php echo $text; ?></a><?php
}
?>